#include <FlexCAN.h>
#include <kinetis_flexcan.h>

int led = 13;
FlexCAN CANbus(1000000);
static CAN_message_t rxmsg;
static uint8_t hex[17] = "0123456789abcdef";


void setup() {

  Serial.begin(9600);
  while (!Serial) ; // wait for Arduino Serial Monitor
  Serial.println(F("Teensy 3.2 CAN Test"));

  CANbus.begin();
  pinMode(led, OUTPUT);
  digitalWrite(led, 1);

  delay(1000);

}

void loop() {
  // put your main code here, to run repeatedly:
  if (CANbus.read(rxmsg)) {
    // Light off to indicate FIFO is not being polled
    digitalWrite(led, 0);

    // Construct String
    String text = "ID: 0x";
    text = String(text + String(rxmsg.id, HEX));
    text = String(text + " DLC: ");
    text = String(text + String(rxmsg.len, HEX));

    //if(String(rxmsg.id, HEX) == "2000" || String(rxmsg.id, HEX) == "2001") { return; }

    // check if DLC is > 0
    if (rxmsg.len >= 1) {
      text = String(text + " DATA: ");
    }

    // construct string for available bytes
    for (int idx = 0; idx < rxmsg.len; ++idx) {
      text = String(text + String(rxmsg.buf[idx], HEX));
      text = String(text + " ");
    }

    // print result
    Serial.println(text);

    // LED Back on to indicate watching FIFO
    digitalWrite(led, 1);
    
  }

}
